# Monorepo projects with Azure Pipelines

Starting in [Enterprise edition](https://www.sonarsource.com/plans-and-pricing/enterprise/), you can add the SonarQube Server analysis to your Azure build pipeline for a monorepo.

Proceed as follows:

1. If not already done, import your monorepo to create the corresponding projects in SonarQube Server: see [Managing monorepo projects](/sonarqube-server/2026.2/project-administration/monorepos.md).
2. For each project, configure the analysis parameters, see **Configuring the project analysis parameters** in [Importing your Azure DevOps repository](/sonarqube-server/2026.2/project-administration/creating-project/azure-devops/import-repos.md).
3. For each project, set up integration features, see [Setting up Azure integration for your project](/sonarqube-server/2026.2/project-administration/creating-project/azure-devops/setting-up-project-integration.md).
4. Add the SonarQube Server analysis to your YAML pipeline. To do so, see the section corresponding to your project type and use the YAML file example below:
   * [Gradle or Maven project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/gradle-or-maven-project.md)
   * [.NET project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/dotnet-project.md)
   * [C family project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/c-family-project.md)
   * [JS, TS, Go, Python, PHP, etc. project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/js-ts-go-python-php.md)

## Typical YAML file example for a monorepo analysis <a href="#yaml-file-example" id="yaml-file-example"></a>

```yaml
# Template pipeline that build 2 distinct .NET projects, living in 2 separate folders in the repo. We are analyzing them on SonarQube Server, each targets a specific SonarQube Server project.
 
 
trigger:
- main # or the name of the main branch
 
pool:
 vmImage: windows-latest
 
steps:
- task: VisualStudioTestPlatformInstaller@1
 inputs:
   packageFeedSelector: 'nugetOrg'
   versionSelector: 'latestPreRelease'
 
- task: UseDotNet@2
 inputs:
   packageType: 'sdk'
   version: '6.x'
   includePreviewVersions: true
 
- task: NuGetToolInstaller@1
 inputs:
   versionSpec: '5.9.0'
   checkLatest: true
 
- task: DotNetCoreCLI@2
 inputs:
   command: 'restore'
   projects: '**/*.sln'
   feedsToUse: 'select'
 
- task: SonarQubePrepare@7
 inputs:
   SonarQube: '<YourSonarqubeServerEndpoint>'
   scannerMode: 'dotnet'
   projectKey: 'myRepo_myProject1'
 
- task: DotNetCoreCLI@2
 inputs:
   command: 'build'
   projects: 'myproject1/solution.sln'
   arguments: '/nr:false' // this flag is important to avoid DLL lock for the 2nd build/analysis
 
- task: SonarQubeAnalyze@7
 
- task: SonarQubePrepare@7
 inputs:
   SonarQube: '<YourSonarqubeServerEndpoint>'
   scannerMode: 'dotnet'
   projectKey: 'myRepo_myProject2'
 
- task: DotNetCoreCLI@2
 inputs:
   command: 'build'
   projects: 'myProject2/solution.sln'
   arguments: '/nr:false'
 
- task: SonarQubeAnalyze@7
```

* [Gradle or Maven project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/gradle-or-maven-project.md)
* [.NET project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/dotnet-project.md)
* [C family project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/c-family-project.md)
* [JS, TS, Go, Python, PHP, etc. project with Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/js-ts-go-python-php.md)
* [Using Azure DevOps extension's features](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/various-features.md)
* [Quality gate status in release pipeline](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/quality-gate-status-in-release-pipeline.md)
* [SonarQube tasks for Azure Pipelines](/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/sonarqube-tasks.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sonarsource.com/sonarqube-server/2026.2/analyzing-source-code/ci-integration/azure-pipelines/monorepo-projects.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
